with Hash_Table_Test_Pkg,
   Ada.Strings.Unbounded,
   Ada.Text_Io;

use Ada.Text_Io,
   Hash_Table_Test_Pkg,
   Hash_Table_Test_Pkg.String_Integer_Hash_Tables,
   Hash_Table_Test_Pkg.String_Integer_Hash_Tables.Value_Lists,
   Ada.Strings.Unbounded;


procedure Hash_Table_Test is 

   function "+" (
         Item : String ) 
     return Unbounded_String is 
   begin
      return To_Unbounded_String(Item);
   end;

   procedure Print_Items (
         Items : Value_List_Accesses ) is 
      I,  
      I_End : Iterator;  
   begin
      I := Get_Begin(Items.all);
      I_End := Get_End(Items.all);

      while I /= I_End loop
         Put_Line(Integer'Image(Dereference(I)));
         Increment(I);
      end loop;
   end;

   Table : Hash_Table;  
   Items : Value_List_Accesses;  

begin
   Put_Line("Hash Table Test");
   Set_Modulo(Table, 11);

   Put_Line("Insert(Table,+""Aja"", 1);");
   Insert(Table,+"Aja", 1);
   Put_Line("Get_Values_Access(Table, +""Aja"", Items);");
   Get_Values_Access(Table, +"Aja", Items);
   Put_Line("Print_Items(Items);");
   Print_Items(Items);

   New_Line(2);

   --Items := null;
   Put_Line("Insert(Table,+""Aja"", 2);");
   Insert(Table,+"Aja", 2);
   Put_Line("Get_Values_Access(Table, +""Aja"", Items);");
   Get_Values_Access(Table, +"Aja", Items);
   Put_Line("Print_Items(Items);");
   Print_Items(Items);

   New_Line(2);
   begin
      Put_Line("Get_Values_Access(Table, +""not included"", Items);");
      Get_Values_Access(Table, +"not included", Items);
      Put_Line("Print_Items(Items);");
      Print_Items(Items);
   exception
      when Key_Not_Found =>
         Put_Line("OK - key not found exception");
      end;
   end;