with Ada.Text_Io,
   Ada.Numerics.Discrete_Random,
   Ada.Unchecked_Deallocation,
   Paskma.Sorts;

use Ada.Text_Io;



procedure Quick_Sort_Test is 

   package Integer_Qsort is new Paskma.Sorts(Integer, "<", ">");
   use Integer_Qsort;

   procedure Check_Sort (
         Vector : Vector_Type ) is 
   begin
      for I in Vector'First..Vector'Last -1 loop
         if Vector(I)>Vector(I+1) then
            Put_Line("sort_errorrrrrr");
            delay 10.0;
            return;
         end if;
      end loop;
   end;



   type Vector_Type_Access is access Vector_Type; 
   Test : Vector_Type_Access;  

   procedure Free is 
   new Ada.Unchecked_Deallocation(Vector_Type, Vector_Type_Access);

   package Randoms is new Ada.Numerics.Discrete_Random(Integer);
   use Randoms;
   G : Generator;  

   Size : Integer;  

   T : Vector_Type (1 .. 3) := (2, 3, 1);  

begin

   Quick_Sort(T);
   Check_Sort(T);

   Put_Line("goinhre");

   Reset(G);
   for I in 1..100 loop
      Free(Test);
      Size := abs(Random(G) mod I*1_001);
      Test := new Vector_Type(1..Size);
      for I in Test.all'range loop
         Test.all(I) := Random(G);
      end loop;
      Put_Line("Sorting array of " & Integer'Image(Size) & " items");
      Quick_Sort(Test.all);
      Check_Sort(Test.all);
   end loop;

end;