with Ada.Finalization,
   Ada.Strings.Unbounded;

use Ada.Finalization,
   Ada.Strings.Unbounded;

package Access_Rights is

   type Access_Right_Type is 
         (File_Read,        
          File_Write,       
          File_Delete,      
          File_Append,      
          Directory_List,   
          Directory_Create, 
          Directory_Delete); 

   type Access_Right_Set is array (Access_Right_Type) of Boolean; 

   type Access_Manager_Type is new Controlled with private; 

   function To_String (
         Obj : in     Access_Manager_Type ) return String; 

   procedure Include (
         Obj   : in out Access_Manager_Type; 
         Value :        Access_Right_Type    ); 

   procedure Exclude (
         Obj   : in out Access_Manager_Type; 
         Value :        Access_Right_Type    ); 

   function Is_Included (
         Obj   : in     Access_Manager_Type; 
         Value :        Access_Right_Type    ) 
     return Boolean; 

   procedure Set (
         Obj       : in out Access_Manager_Type; 
         With_Data :        Unbounded_String     ); 

   procedure Initialize (
         Obj : in out Access_Manager_Type ); 

private

   type Access_Manager_Type is new Controlled with 
      record 
         Rights : Access_Right_Set;  
      end record; 

end Access_Rights;