with Ada.Strings.Unbounded,
   Paskma.Lists,
   Ada.Text_Io,
   Access_Rights;

use Ada.Strings.Unbounded,
   Ada.Text_Io,
   Access_Rights;

package Configuration_Mycelium is

   Invalid_Line : exception;  

   function Get_Key (
         Line : Unbounded_String ) 
     return Unbounded_String; 

   function Get_Value (
         Line : Unbounded_String ) 
     return Unbounded_String; 

   function Get_Line (
         File : File_Type ) 
     return Unbounded_String; 


   --
   -- Represents one physical directory which can be accesed over ftp
   type Shared_Directory_Type is 
      record 
         Name   : Unbounded_String;  
         Rights : Access_Manager_Type;  
      end record; 

   package Shared_Dir_Lists is new Paskma.Lists(Shared_Directory_Type);

   --
   -- Configuration of one user
   type User_Configuration_Type is 
      record 
         Username,  
         Password,  
         Root_Directory : Unbounded_String;  
         Directories    : Shared_Dir_Lists.List;  
      end record; 

   package User_Conf_Lists is new Paskma.Lists(User_Configuration_Type);


   procedure Log (
         User_Configuration : User_Configuration_Type ); 


   --
   -- The directory will be mapped into root directory under an alias
   type Mapping_Type is 
      record 
         Directory,  
         Alias     : Unbounded_String;  
      end record; 

   package Mapping_Lists is new Paskma.Lists(Mapping_Type);


   procedure Log (
         Mapping : Mapping_Type ); 

end Configuration_Mycelium;