with Paskma.Lists,
   Ada.Calendar,
   Ada.Strings.Unbounded;

use Ada.Strings.Unbounded,
   Ada.Calendar;

package Directory_Listings is

   Listing_Error : exception;  

   type File_Attribute_Type is 
         (Directory, 
          Read_Only); 

   type File_Attribute_Set is array (File_Attribute_Type) of Boolean; 

   type Directory_Item_Type is 
      record 
         Name          : Unbounded_String;  
         Size          : Long_Long_Integer;  
         Attributes    : File_Attribute_Set;  
         Creation_Time : Time;               -- Time is new duration             
      end record; 

   package Directory_Item_Lists is new Paskma.Lists(Directory_Item_Type);

   procedure Get_Listing (
         Directory_Name : Unbounded_String; 
         -- If it is use for single file then, in case of directory, _ 
         -- it mus be without end (back)slash.
         Result          : in out Directory_Item_Lists.List;        
         Attach_Asterisk :        Boolean                   := True ); 
   -- When the attach_asterisk is set to be false then this procedure _
   -- can be used to determine file attributes of a single file (any file, _
   -- not only directory).

   --
   -- Is Directory
   --
   -- Debug function. Can be used instead of gnat.os_lib.is_directory

   function Is_Directory (
         Name : String ) 
     return Boolean; 

end Directory_Listings;