with Gnat.Sockets,
   Ada.Numerics.Discrete_Random;

use Gnat.Sockets;

package Port_Generator is

   subtype Client_Port_Type is Port_Type range 3_333..33_333;
   package Client_Randoms is new Ada.Numerics.Discrete_Random(Client_Port_Type);
   use Client_Randoms;

   protected type Port_Generator_Type is
      procedure Get_New_Port (
            Result :    out Port_Type ); 
      procedure Reset; 
   private
      G : Generator;
   end Port_Generator_Type;

   --
   -- The only instance
   The_Port_Generator : Port_Generator_Type;  


end Port_Generator;