with Ada.Strings.Unbounded;

use Ada.Strings.Unbounded;

package Task_Id_Types is

   type Task_Id_Type is mod Integer'Last; -- never overflows

   function Unique_Task_Id return Task_Id_Type; 
   -- Returns unique task_id; Thread safe.

   --
   -- Log
   --
   -- Logging procedure for task_id_type

   procedure Log (
         Id      : Task_Id_Type; 
         Message : String        ); 

   procedure Log (
         Id      : Task_Id_Type;    
         Message : Unbounded_String ); 

private

   protected type Task_Id_Generator is
      procedure Get_New_Task_Id (
            Result :    out Task_Id_Type ); 
   private
      Task_Id_Counter : Task_Id_Type := 0;
   end Task_Id_Generator;

end Task_Id_Types;