unit BridgeReaderU;

interface

uses
  Classes;

type
  TBridgeReader = class(TThread)
  private
    element : char;
    terminatingUI : boolean;
  protected
    procedure Execute; override;
    procedure UpdateConsole;
  public
    procedure TerminateUI;
  end;

implementation

uses frmMainU, windows, messages;

{ Important: Methods and properties of objects in VCL or CLX can only be used
  in a method called using Synchronize, for example,

      Synchronize(UpdateCaption);

  and UpdateCaption could look like,

    procedure TBridgeReader.UpdateCaption;
    begin
      Form1.Caption := 'Updated in a thread';
    end; }

{ TBridgeReader }

procedure TBridgeReader.Execute;
begin
   terminatingUI := false;
   repeat
     child.read(element);
     child.writetolog(element);
     if not terminatingUI then Synchronize(UpdateConsole);
   until false;
end;

procedure TBridgeReader.UpdateConsole;
begin
   if element = #10 then exit;//when we pressing <enter> we send only one byte - #13
   
   frmMain.txtConsole.ReadOnly := false;
   sendMessage(frmMain.txtConsole.Handle, WM_CHAR, integer(element), 1);
   sendMessage(frmMain.txtConsole.Handle, EM_LINESCROLL, 0, 1);
   frmMain.txtConsole.ReadOnly := true;
end;

procedure TBridgeReader.TerminateUI;
begin
  terminatingUI := true;
end;

end.
