unit frmExitU;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls;

type
  TfrmExit = class(TForm)
    pbExit: TProgressBar;
    btnCancel: TButton;
    tmrCountDown: TTimer;
    lblExitInfo: TLabel;
    btnExitNow: TButton;
    procedure btnCancelClick(Sender: TObject);
    procedure tmrCountDownTimer(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btnExitNowClick(Sender: TObject);
  private
    { Private declarations }
    CountDown : integer;
  public
    { Public declarations }
  end;

const
  COUNT_DOWN_LIMIT = 5;

var
  frmExit: TfrmExit;

implementation

{$R *.dfm}

procedure TfrmExit.btnCancelClick(Sender: TObject);
begin
    tmrCountDown.Enabled := false;
    ModalResult := mrCancel;
end;

procedure TfrmExit.tmrCountDownTimer(Sender: TObject);
begin
    if CountDown = 0 then
    begin
      ModalResult := mrOk;
    end;

    CountDown := CountDown - 1;
    pbExit.Position := CountDown * 100 div COUNT_DOWN_LIMIT;

    lblExitInfo.Caption := 'This application will be terminated in '
    + IntToStr(CountDown) + ' seconds.';

end;

procedure TfrmExit.FormShow(Sender: TObject);
begin
   lblExitInfo.Caption := 'This application will be terminated.';
   CountDown := COUNT_DOWN_LIMIT;
   pbExit.Position := 100;
   tmrCountDown.Enabled := true;
end;

procedure TfrmExit.btnExitNowClick(Sender: TObject);
begin
  ModalResult := mrOk;
end;

end.
