unit frmMainU;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, bridgeU, StdCtrls, ComCtrls, BridgeReaderU, ToolWin, ExtCtrls,
  ImgList;

type
  TfrmMain = class(TForm)
    txtConsole: TRichEdit;
    ToolBar1: TToolBar;
    btnExit: TToolButton;
    btnTrafic: TToolButton;
    Panel1: TPanel;
    Label1: TLabel;
    btnTray: TToolButton;
    btnHelp: TToolButton;
    txtMessage: TComboBox;
    btnRestart: TToolButton;
    btnStatus: TToolButton;
    ilsToolbar: TImageList;
    btnAbout: TToolButton;
    tmrMinimize: TTimer;
    btnRunnamer: TToolButton;
    btnUptime: TToolButton;
    procedure txtMessageKeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
    procedure btnExitClick(Sender: TObject);
    procedure btnTraficClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnTrayClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnHelpClick(Sender: TObject);
    procedure btnStatusClick(Sender: TObject);
    procedure btnRestartClick(Sender: TObject);
    procedure btnAboutClick(Sender: TObject);
    procedure tmrMinimizeTimer(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure btnRunnamerClick(Sender: TObject);
    procedure btnUptimeClick(Sender: TObject);
  private
    procedure SendWithAssistance(msg : string);
  public
    procedure WMUser (var msg:TMessage);message wm_user;
  end;

var
  frmMain: TfrmMain;

  child : TBridge; // the global FUNDAMENTAL object
  child_reader : TBridgeReader;

implementation

uses taskbaricon, frmAboutU, frmExitU;

{$R *.dfm}



procedure TfrmMain.txtMessageKeyPress(Sender: TObject; var Key: Char);

begin
  if key = #13 then
  begin
    txtMessage.Items.Insert(0, txtMessage.Text);
    sendWithAssistance(txtMessage.Text);
    txtMessage.Text := '';
    key := #0;
  end;
end;

procedure TfrmMain.SendWithAssistance(msg : string);
var i : integer;
begin
   try
      txtConsole.ReadOnly := false;
      txtConsole.Lines.BeginUpdate;
      for i := 1 to length(msg) do
          SendMessage(txtConsole.Handle, WM_CHAR, integer(msg[i]), 1);
      SendMessage(txtConsole.Handle, WM_CHAR, integer(#13), 1);

      child.send(msg);
      txtConsole.Lines.EndUpdate;
      txtConsole.ReadOnly := true;
   except
     on e : exception do
       ShowMessage(e.Message);
   end;
end;



procedure TfrmMain.FormCreate(Sender: TObject);
begin
  MyTaskBarAddIcon(Handle, 0, application.Icon.Handle, PCHAR(Caption));
  child := TBridge.Create;
  child.start('pftp.exe');
  child_reader := TBridgeReader.Create(false);
  tmrMinimize.Enabled := true;
end;

procedure TfrmMain.btnExitClick(Sender: TObject);
begin
    if MessageBox(self.Handle, 'Really exit the underlying server?', 'xpftp',  MB_YESNO) = ID_YES then
    begin
      sendWithAssistance('exit');
    end;
end;

procedure TfrmMain.btnTraficClick(Sender: TObject);
begin
  SendWithAssistance('traffic');
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
  MyTaskBarDeleteIcon(Handle,0);
end;

procedure TfrmMain.btnTrayClick(Sender: TObject);
begin
  Application.Minimize;
  ShowWindow(Application.Handle,SW_HIDE);
end;

procedure TFrmMain.WMUser (var msg:TMessage);
begin
 if (msg.lParam=WM_LBUTTONUP) or (msg.lParam=WM_RBUTTONUP) then
 begin
  Application.Restore;
  ShowWindow(Application.Handle,SW_HIDE);
  Application.BringToFront;
 end;
end;

procedure TfrmMain.FormShow(Sender: TObject);
begin
  txtMessage.SetFocus;
end;

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    child_reader.TerminateUI;
    Hide;// to hide ending delay from user (me to sralo, no)
    child.Destroy;
end;

procedure TfrmMain.btnHelpClick(Sender: TObject);
begin
  SendWithAssistance('help');
end;

procedure TfrmMain.btnStatusClick(Sender: TObject);
begin
  SendWithAssistance('status');
end;

procedure TfrmMain.btnRestartClick(Sender: TObject);
begin
  SendWithAssistance('restart');
end;

procedure TfrmMain.btnAboutClick(Sender: TObject);
begin
  frmAbout.ShowModal;
end;

procedure TfrmMain.tmrMinimizeTimer(Sender: TObject);
begin
      tmrMinimize.Enabled := false;
      btnTrayClick(self);
end;

procedure TfrmMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
{  If MessageBox(self.Handle, 'Really exit?', 'xpftp', MB_YESNO) = IDNO then
     canClose := false;
}
    if frmExit.ShowModal = mrOk then
       canClose := true
    else
       canClose := false;
end;

procedure TfrmMain.btnRunnamerClick(Sender: TObject);
var
     si : TStartupInfo;
     pi : PROCESS_INFORMATION;
     
begin
      FillMemory(@si, sizeof(si), 0);
      FillMemory(@pi, sizeof(pi), 0);
      
      CreateProcess('namer.exe',//child executable
                 nil,//command line
                 nil,//security attributes
                 nil,//thread security attributes
                 true,//interit handles
                 0,//creation flags
                 nil,//enviroment
                 nil,//current directory
                 si,//startup info
                 pi// out; process information
                );
end;

procedure TfrmMain.btnUptimeClick(Sender: TObject);
begin
   SendWithAssistance('uptime');
end;

end.
